/*
  Copyright (c) 2009 by Jakob Schroeter <js@camaya.net>
  This file is part of the glooxd library. http://camaya.net/glooxd

  This software is distributed under a license. The full license
  agreement can be found in the file LICENSE in this distribution.
  This software may not be copied, modified, sold or distributed
  other than expressed in the named license agreement.

  This software is distributed without any warranty.
*/


#ifndef CERTIFICATEPROVIDER_H__
#define CERTIFICATEPROVIDER_H__

#include "macros.h"

#ifdef HAVE_OPENSSL
#include <openssl/ssl.h>
#endif

namespace glooxd
{

  /**
   *
   */
  class GLOOXD_API CertificateProvider
  {
    public:
      /**
       * Virtual destructor.
       */
      virtual ~CertificateProvider() {}

      /**
       *
       */
      virtual const std::string handleCertificateRequest( const std::string& domain ) = 0;

      /**
       *
       */
      virtual const std::string handleKeyRequest( const std::string& domain ) = 0;

  };
}

#endif // CERTIFICATEPROVIDER_H__
