/*
  Copyright (c) 2008-2009 by Jakob Schroeter <js@camaya.net>
  This file is part of the glooxd library. http://camaya.net/glooxd

  This software is distributed under a license. The full license
  agreement can be found in the file LICENSE in this distribution.
  This software may not be copied, modified, sold or distributed
  other than expressed in the named license agreement.

  This software is distributed without any warranty.
*/


#ifndef GLOOXDD_MACROS_H__
#define GLOOXD_MACROS_H__

#if defined( _MSC_VER ) || defined( _WIN32_WCE )
#  pragma warning( disable:4251 )
#  pragma warning( disable:4786 )
#endif

#ifdef _WIN32
#  ifdef GLOOXD_EXPORTS
#    define GLOOXD_API __declspec( dllexport )
#  else
#    ifdef GLOOXD_IMPORTS
#      define GLOOXD_API __declspec( dllimport )
#    endif
#  endif
#endif

#ifndef GLOOXD_API
#  define GLOOXD_API
#endif


#if defined( __GNUC__ ) && ( __GNUC__ - 0 > 3 || ( __GNUC__ - 0 == 3 && __GNUC_MINOR__ - 0 >= 2 ) )
#  define GLOOXD_DEPRECATED __attribute__ ( (__deprecated__) )
#  define GLOOXD_DEPRECATED_CTOR explicit GLOOXD_DEPRECATED
#elif defined( _MSC_VER ) && ( _MSC_VER >= 1300 )
#  define GLOOXD_DEPRECATED __declspec( deprecated )
#  define GLOOXD_DEPRECATED_CTOR explicit GLOOXD_DEPRECATED
#else
#  define GLOOXD_DEPRECATED
#  define GLOOXD_DEPRECATED_CTOR
#endif


#endif // GLOOXD_MACROS_H__
