/*
  Copyright (c) 2008-2009 by Jakob Schroeter <js@camaya.net>
  This file is part of the glooxd library. http://camaya.net/glooxd

  This software is distributed under a license. The full license
  agreement can be found in the file LICENSE in this distribution.
  This software may not be copied, modified, sold or distributed
  other than expressed in the named license agreement.

  This software is distributed without any warranty.
*/


#ifndef ROSTERPROVIDER_H__
#define ROSTERPROVIDER_H__

#include "macros.h"

#include <gloox/gloox.h>
#include <gloox/jid.h>

#include <string>
#include <map>

namespace glooxd
{

  /**
   * A simple map of JID/subscription type pairs.
   * @note Will eventually be replaced by gloox::Roster.
   */
  typedef std::map<std::string, gloox::SubscriptionType> Roster;

  /**
   * @brief
   *
   * @author Jakob Schroeter <js@camaya.net>
   */
  class GLOOXD_API RosterProvider
  {
    public:
      /**
       * Virtual destructor.
       */
      virtual ~RosterProvider() {}

      /**
       * @param jid The JID to return the roster for.
       * @return A map of subscription/JID pairs.
       */
      virtual const Roster getRoster( const gloox::JID& jid ) = 0;

  };

}

#endif // ROSTERPROVIDER_H__
