/*
  Copyright (c) 2008-2009 by Jakob Schroeter <js@camaya.net>
  This file is part of the glooxd library. http://camaya.net/glooxd

  This software is distributed under a license. The full license
  agreement can be found in the file LICENSE in this distribution.
  This software may not be copied, modified, sold or distributed
  other than expressed in the named license agreement.

  This software is distributed without any warranty.
*/


#ifndef GLOOXDTAGHANDLER_H__
#define GLOOXDTAGHANDLER_H__

#include "glooxd.h"

#include <gloox/tag.h>

namespace glooxd
{

  /**
   * @brief A base class for entities that handles Tags for a specific domain.
   *
   * @author Jakob Schroeter <js@camaya.net>
   * @since 0.2
   */
  class GLOOXD_API TagHandler
  {
    public:
      /**
       * Virtual destructor.
       */
      virtual ~TagHandler() {}

      /**
       *
       */
      virtual void handleIncomingTag( gloox::Tag* tag ) = 0;

      /**
       *
       */
      virtual void handleOutgoingTag( gloox::Tag* tag ) = 0;

  };

}

#endif // GLOOXDTAGHANDLER_H__
