/*
  Copyright (c) 2009 by Jakob Schroeter <js@camaya.net>
  This file is part of the glooxd library. http://camaya.net/glooxd

  This software is distributed under a license. The full license
  agreement can be found in the file LICENSE in this distribution.
  This software may not be copied, modified, sold or distributed
  other than expressed in the named license agreement.

  This software is distributed without any warranty.
*/


#include "sm.h"
#include "taghandler.h"
#include "vcardmanager.h"

#include <gloox/gloox.h>
#include <gloox/iq.h>
#include <gloox/tag.h>
#include <gloox/vcard.h>

namespace glooxd
{

  VCardManager::VCardManager( SM& sm, TagHandler& router )
    : Plugin( sm, router )
  {
  }

  VCardManager::~VCardManager()
  {
  }

  const std::string& VCardManager::filterString() const
  {
    static const std::string filter = "/iq[/iq/vCard[@xmlns='" + gloox::XMLNS_VCARD_TEMP + "']]";
    return filter;
  }

  bool VCardManager::handleTag( const gloox::Tag* tag )
  {
    if( !tag )
      return false;

    printf( "received a vcard tag!!!!!!!!!! %s\n", tag->xml().c_str() );

    gloox::IQ re( gloox::IQ::Result, tag->findAttribute( "from" ),
                  tag->findAttribute( "id" ) );
    re.setFrom( tag->findAttribute( "to" ) );
    re.addExtension( new gloox::VCard() );
    m_router.handleIncomingTag( re.tag() );

    return true;
  }


}
