/*
  Copyright (c) 2009 by Jakob Schroeter <js@camaya.net>
  This file is part of the glooxd library. http://camaya.net/glooxd

  This software is distributed under a license. The full license
  agreement can be found in the file LICENSE in this distribution.
  This software may not be copied, modified, sold or distributed
  other than expressed in the named license agreement.

  This software is distributed without any warranty.
*/


#ifndef VCARDMANAGER_H__
#define VCARDMANAGER_H__

#include "glooxd.h"
#include "plugin.h"

namespace gloox
{
  class JID;
  class Tag;
}

namespace glooxd
{

  /**
   * @brief An implementation of the server-side presence management.
   *
   * @author Jakob Schroeter <js@camaya.net>
   * @since 0.2
   */
  class GLOOXD_API VCardManager : public Plugin
  {
    public:
      /**
       * Constructor.
       * @param sm The SM to use.
       * @param router The Router to use.
       */
      VCardManager( SM& sm, TagHandler& router );

      /**
       * Virtual destructor.
       */
      virtual ~VCardManager();

      // reimplemented from Plugin
      virtual bool handleTag( const gloox::Tag* tag );

      // reimplemented from Plugin
      virtual const std::string& filterString() const;

    private:

  };

}

#endif // VCARDMANAGER_H__
